/******************************************************************************/
/* CD_COMND.H								      */
/******************************************************************************/

#ifndef	__HEADER_CD_COMND
#define	__HEADER_CD_COMND	__HEADER_CD_COMND

/* -------------------------------------------------------------------------- */
/* commands from user processor to servo processor */

#define	COMND_PLAYTRACK		0x0100
#define	COMND_STOP		0x0200
#define	COMND_READTOC		0x0300
#define	COMND_PAUSE		0x0400
#define	COMND_PAUSERELEASE	0x0500

#define	COMND_GETTITLELEN	0x0900
#define	COMND_OPENTRAY		0x0A00
#define	COMND_CLOSETRAY		0x0B00

#define	COMND_GETCOMPLETETIME	0x0D00

#define	COMND_GOTOTIME_ABSMINS	0x1000
#define	COMND_GOTOTIME_ABSSECS	0x1100
#define	COMND_GOTOTIME_ABSFRMS	0x1200

#define	COMND_READLONGTOC	0x1400
#define	COMND_SETMODE		0x1500
#define	COMND_GETLASTERROR	0x1600
#define	COMND_CLEARERROR	0x1700
#define	COMND_SPINUP		0x1800

#define	COMND_PLAYA2B_STRTMINS	0x2000
#define	COMND_PLAYA2B_STRTSECS	0x2100
#define	COMND_PLAYA2B_STRTFRMS	0x2200
#define	COMND_PLAYA2B_STOPMINS	0x2300
#define	COMND_PLAYA2B_STOPSECS	0x2400
#define	COMND_PLAYA2B_STOPFRMS	0x2500
#define	COMND_RELEASEA2B	0x2600

#define	COMND_GETDISCSTATUS	0x5000
#define	COMND_SETVOLUME		0x5100

#define	COMND_GETSESSIONINFO	0x5400
#define	COMND_SETDACMODE	0x7000

#define	COMND_SERVICE		0xF000
#define	COMND_SLEDGE		0xF100
#define	COMND_FOCUS		0xF200
#define	COMND_TURNTABLE		0xF300
#define	COMND_RADIAL		0xF400

/* commands from servo processor to user processor */

#define	COMND_FOUND		0x0100
#define	COMND_STOPPED		0x0200
#define	COMND_DISCSTATUS	0x0300
#define	COMND_ERRORVALUES	0x0400

#define	COMND_TRACKLEN_LSB	0x0900
#define	COMND_TRACKLEN_MSB	0x0A00
#define	COMND_TRAYMOVING	0x0B00
#define	COMND_TRAYOPEN		0x0C00
#define	COMND_TRAYCLOSED	0x0D00

#define	COMND_ACTUALTITLE	0x1000
#define	COMND_ACTUALINDEX	0x1100
#define	COMND_ACTUALMINS	0x1200
#define	COMND_ACTUALSECS	0x1300
#define	COMND_ABSOLUTE_MINS	0x1400
#define	COMND_ABSOLUTE_SECS	0x1500
#define	COMND_ABSOLUTE_FRMS	0x1600
#define	COMND_MODESTATUS	0x1700

#define	COMND_TOCVAL_MINTRACK	0x2000
#define	COMND_TOCVAL_MAXTRACK	0x2100
#define	COMND_TOCVAL_STRTMINS	0x2200
#define	COMND_TOCVAL_STRTSECS	0x2300
#define	COMND_TOCVAL_STRTFRMS	0x2400

#define	COMND_A2BRELEASED	0x2600

#define	COMND_VOLUMELEVEL	0x5100

#define	COMND_SESSIONINFO	0x5400

#define	COMND_LONGTOC_TRACKNO	0x6000
#define	COMND_LONGTOC_ATTRS	0x6100
#define	COMND_LONGTOC_STRTMINS	0x6200
#define	COMND_LONGTOC_STRTSECS	0x6300
#define	COMND_LONGTOC_STRTFRMS	0x6400

#define	COMND_DACMODE		0x7000

#define	COMND_SERVOVERSIONNO	0xF000

/* -------------------------------------------------------------------------- */
/* error codes for different error conditions in the CD Module */

#define	COMND_E_NOERROR		0x0000	/* no error */
#define	COMND_E_FOCUSORNODISC	0x0002	/* focus error or no disc in the drive */
#define	COMND_E_INVSUBCODE	0x0007	/* no valid subsode */
#define	COMND_E_READTOC		0x0008	/* out of lead in area while reading TOC */
#define	COMND_E_RADIAL		0x000A	/* radial error */
#define	COMND_E_FATALSLEDGE	0x000C	/* fatal sledge error */
#define	COMND_E_TURNTABLE	0x000D	/* turntable motor error */
#define	COMND_E_SRCHTIMEOUT	0x001F	/* search time out */
#define	COMND_E_SRCHBINARY	0x0020	/* search binary error */ 
#define	COMND_E_SRCHINDEX	0x0021	/* search index error */
#define	COMND_E_SRCHTIME	0x0022	/* search time error */
#define	COMND_E_ILLCOMMAND	0x0028	/* illegal command */
#define	COMND_E_ILLVALUE	0x0029	/* illegal value */
#define	COMND_E_ILLTIME		0x002A	/* illegal time */
#define	COMND_E_COMMUNICATION	0x002B	/* communication error */
#define	COMND_E_TRAY		0x002C	/* tray error */
#define	COMND_E_HFDETECTOR	0x002D	/* HF detector error */

/* -------------------------------------------------------------------------- */

#define	BC_CON	2

/* -------------------------------------------------------------------------- */

static	void	cd_comnd_emulate( void );
static	int	cd_comnd_initialise( void );
static	int	cd_comnd_checkkbd( void );

static	void	cd_comnd_playtitle( unsigned int );
static	void	cd_comnd_stop( unsigned int );
static	void	cd_comnd_readtoc( unsigned int );
static	void	cd_comnd_pause( unsigned int );
static	void	cd_comnd_unpause( unsigned int );
static	void	cd_comnd_gettitlelen( unsigned int );
static	void	cd_comnd_getcomptime( unsigned int );
static	void	cd_comnd_gotoabsfrm( unsigned int );
static	void	cd_comnd_readlongtoc( unsigned int );
static	void	cd_comnd_geterror( unsigned int );
static	void	cd_comnd_clearerror( unsigned int );
static	void	cd_comnd_spinup( unsigned int );
static	void	cd_comnd_plabstopfrm( unsigned int );
static	void	cd_comnd_abrelease( unsigned int );
static	void	cd_comnd_getmaxsession( unsigned int );

static	void	cd_comnd_senderror( unsigned int );
static	void	cd_comnd_respond( unsigned int );

static	void	cd_comnd_delay( unsigned int );
static	void	cd_comnd_seekdelay( unsigned long, unsigned long );

static	void	cd_comnd_discspin( int );
static	void	cd_comnd_playreset( void );
static	void	cd_comnd_setlast( unsigned long );
static	void	cd_comnd_seek( void );
static	void	cd_comnd_playset( void );
static	int	cd_comnd_seekread( void );
static	int	cd_comnd_setread( void );
static	void	cd_comnd_readdata( void );

/* -------------------------------------------------------------------------- */

static	void	cd_comnd_reserved( unsigned int );
static	void	cd_comnd_userdef( unsigned int );
static	void	cd_comnd_undefined( unsigned int );

static	void	cd_comnd_opentray( unsigned int );
static	void	cd_comnd_closetray( unsigned int );
static	void	cd_comnd_setmode( unsigned int );
static	void	cd_comnd_getdiscstatus( unsigned int );
static	void	cd_comnd_setvolume( unsigned int );
static	void	cd_comnd_setdacmode( unsigned int );

static	void	cd_comnd_gotoabsmin( unsigned int );
static	void	cd_comnd_gotoabssec( unsigned int );
static	void	cd_comnd_plabstrtmin( unsigned int );
static	void	cd_comnd_plabstrtsec( unsigned int );
static	void	cd_comnd_plabstrtfrm( unsigned int );
static	void	cd_comnd_plabstopmin( unsigned int );
static	void	cd_comnd_plabstopsec( unsigned int );

static	void	cd_comnd_service( unsigned int );
static	void	cd_comnd_sledge( unsigned int );
static	void	cd_comnd_focus( unsigned int );
static	void	cd_comnd_turntable( unsigned int );
static	void	cd_comnd_radial( unsigned int );

/* -------------------------------------------------------------------------- */

static	void	(*cd_comnd_functable[])( unsigned int ) =
	{
	/* 00 */	cd_comnd_undefined,
	/* 01 */	cd_comnd_playtitle,
	/* 02 */	cd_comnd_stop,
	/* 03 */	cd_comnd_readtoc,
	/* 04 */	cd_comnd_pause,
	/* 05 */	cd_comnd_unpause,
	/* 06 */	cd_comnd_reserved,
	/* 07 */	cd_comnd_reserved,
	/* 08 */	cd_comnd_reserved,
	/* 09 */	cd_comnd_gettitlelen,
	/* 0A */	cd_comnd_opentray,
	/* 0B */	cd_comnd_closetray,
	/* 0C */	cd_comnd_undefined,
	/* 0D */	cd_comnd_getcomptime,
	/* 0E */	cd_comnd_undefined,
	/* 0F */	cd_comnd_undefined,

	/* 10 */	cd_comnd_gotoabsmin,
	/* 11 */	cd_comnd_gotoabssec,
	/* 12 */	cd_comnd_gotoabsfrm,
	/* 13 */	cd_comnd_undefined,
	/* 14 */	cd_comnd_readlongtoc,
	/* 15 */	cd_comnd_setmode,
	/* 16 */	cd_comnd_geterror,
	/* 17 */	cd_comnd_clearerror,
	/* 18 */	cd_comnd_spinup,
	/* 19 */	cd_comnd_undefined,
	/* 1A */	cd_comnd_undefined,
	/* 1B */	cd_comnd_undefined,
	/* 1C */	cd_comnd_undefined,
	/* 1D */	cd_comnd_undefined,
	/* 1E */	cd_comnd_undefined,
	/* 1F */	cd_comnd_undefined,

	/* 20 */	cd_comnd_plabstrtmin,
	/* 21 */	cd_comnd_plabstrtsec,
	/* 22 */	cd_comnd_plabstrtfrm,
	/* 23 */	cd_comnd_plabstopmin,
	/* 24 */	cd_comnd_plabstopsec,
	/* 25 */	cd_comnd_plabstopfrm,
	/* 26 */	cd_comnd_abrelease,
	/* 27 */	cd_comnd_undefined,
	/* 28 */	cd_comnd_undefined,
	/* 29 */	cd_comnd_undefined,
	/* 2A */	cd_comnd_undefined,
	/* 2B */	cd_comnd_undefined,
	/* 2C */	cd_comnd_undefined,
	/* 2D */	cd_comnd_undefined,
	/* 2E */	cd_comnd_undefined,
	/* 2F */	cd_comnd_undefined,

	/* 30 */	cd_comnd_reserved,
	/* 31 */	cd_comnd_undefined,
	/* 32 */	cd_comnd_undefined,
	/* 33 */	cd_comnd_undefined,
	/* 34 */	cd_comnd_undefined,
	/* 35 */	cd_comnd_undefined,
	/* 36 */	cd_comnd_undefined,
	/* 37 */	cd_comnd_undefined,
	/* 38 */	cd_comnd_undefined,
	/* 39 */	cd_comnd_undefined,
	/* 3A */	cd_comnd_undefined,
	/* 3B */	cd_comnd_undefined,
	/* 3C */	cd_comnd_undefined,
	/* 3D */	cd_comnd_undefined,
	/* 3E */	cd_comnd_undefined,
	/* 3F */	cd_comnd_undefined,

	/* 40 */	cd_comnd_reserved,
	/* 41 */	cd_comnd_reserved,
	/* 42 */	cd_comnd_reserved,
	/* 43 */	cd_comnd_reserved,
	/* 44 */	cd_comnd_reserved,
	/* 45 */	cd_comnd_undefined,
	/* 46 */	cd_comnd_undefined,
	/* 47 */	cd_comnd_undefined,
	/* 48 */	cd_comnd_undefined,
	/* 49 */	cd_comnd_undefined,
	/* 4A */	cd_comnd_undefined,
	/* 4B */	cd_comnd_undefined,
	/* 4C */	cd_comnd_undefined,
	/* 4D */	cd_comnd_undefined,
	/* 4E */	cd_comnd_undefined,
	/* 4F */	cd_comnd_undefined,

	/* 50 */	cd_comnd_getdiscstatus,
	/* 51 */	cd_comnd_setvolume,
	/* 52 */	cd_comnd_reserved,
	/* 53 */	cd_comnd_undefined,
	/* 54 */	cd_comnd_getmaxsession,
	/* 55 */	cd_comnd_undefined,
	/* 56 */	cd_comnd_undefined,
	/* 57 */	cd_comnd_undefined,
	/* 58 */	cd_comnd_undefined,
	/* 59 */	cd_comnd_undefined,
	/* 5A */	cd_comnd_undefined,
	/* 5B */	cd_comnd_undefined,
	/* 5C */	cd_comnd_undefined,
	/* 5D */	cd_comnd_undefined,
	/* 5E */	cd_comnd_undefined,
	/* 5F */	cd_comnd_undefined,

	/* 60 */	cd_comnd_undefined,
	/* 61 */	cd_comnd_undefined,
	/* 62 */	cd_comnd_undefined,
	/* 63 */	cd_comnd_undefined,
	/* 64 */	cd_comnd_undefined,
	/* 65 */	cd_comnd_undefined,
	/* 66 */	cd_comnd_undefined,
	/* 67 */	cd_comnd_undefined,
	/* 68 */	cd_comnd_undefined,
	/* 69 */	cd_comnd_undefined,
	/* 6A */	cd_comnd_undefined,
	/* 6B */	cd_comnd_undefined,
	/* 6C */	cd_comnd_undefined,
	/* 6D */	cd_comnd_undefined,
	/* 6E */	cd_comnd_undefined,
	/* 6F */	cd_comnd_undefined,

	/* 70 */	cd_comnd_setdacmode,
	/* 71 */	cd_comnd_undefined,
	/* 72 */	cd_comnd_undefined,
	/* 73 */	cd_comnd_undefined,
	/* 74 */	cd_comnd_undefined,
	/* 75 */	cd_comnd_undefined,
	/* 76 */	cd_comnd_undefined,
	/* 77 */	cd_comnd_undefined,
	/* 78 */	cd_comnd_undefined,
	/* 79 */	cd_comnd_undefined,
	/* 7A */	cd_comnd_undefined,
	/* 7B */	cd_comnd_undefined,
	/* 7C */	cd_comnd_undefined,
	/* 7D */	cd_comnd_undefined,
	/* 7E */	cd_comnd_undefined,
	/* 7F */	cd_comnd_undefined,

	/* 80 */	cd_comnd_reserved,
	/* 81 */	cd_comnd_reserved,
	/* 82 */	cd_comnd_reserved,
	/* 83 */	cd_comnd_reserved,
	/* 84 */	cd_comnd_undefined,
	/* 85 */	cd_comnd_undefined,
	/* 86 */	cd_comnd_undefined,
	/* 87 */	cd_comnd_undefined,
	/* 88 */	cd_comnd_undefined,
	/* 89 */	cd_comnd_undefined,
	/* 8A */	cd_comnd_undefined,
	/* 8B */	cd_comnd_undefined,
	/* 8C */	cd_comnd_undefined,
	/* 8D */	cd_comnd_undefined,
	/* 8E */	cd_comnd_undefined,
	/* 8F */	cd_comnd_undefined,

	/* 90 */	cd_comnd_undefined,
	/* 91 */	cd_comnd_undefined,
	/* 92 */	cd_comnd_undefined,
	/* 93 */	cd_comnd_undefined,
	/* 94 */	cd_comnd_undefined,
	/* 95 */	cd_comnd_undefined,
	/* 96 */	cd_comnd_undefined,
	/* 97 */	cd_comnd_undefined,
	/* 98 */	cd_comnd_undefined,
	/* 99 */	cd_comnd_undefined,
	/* 9A */	cd_comnd_undefined,
	/* 9B */	cd_comnd_undefined,
	/* 9C */	cd_comnd_undefined,
	/* 9D */	cd_comnd_undefined,
	/* 9E */	cd_comnd_undefined,
	/* 9F */	cd_comnd_undefined,

	/* A0 */	cd_comnd_userdef,
	/* A1 */	cd_comnd_userdef,
	/* A2 */	cd_comnd_userdef,
	/* A3 */	cd_comnd_userdef,
	/* A4 */	cd_comnd_userdef,
	/* A5 */	cd_comnd_userdef,
	/* A6 */	cd_comnd_userdef,
	/* A7 */	cd_comnd_userdef,
	/* A8 */	cd_comnd_userdef,
	/* A9 */	cd_comnd_userdef,
	/* AA */	cd_comnd_userdef,
	/* AB */	cd_comnd_userdef,
	/* AC */	cd_comnd_userdef,
	/* AD */	cd_comnd_userdef,
	/* AE */	cd_comnd_userdef,
	/* AF */	cd_comnd_userdef,

	/* B0 */	cd_comnd_undefined,
	/* B1 */	cd_comnd_undefined,
	/* B2 */	cd_comnd_undefined,
	/* B3 */	cd_comnd_undefined,
	/* B4 */	cd_comnd_undefined,
	/* B5 */	cd_comnd_undefined,
	/* B6 */	cd_comnd_undefined,
	/* B7 */	cd_comnd_undefined,
	/* B8 */	cd_comnd_undefined,
	/* B9 */	cd_comnd_undefined,
	/* BA */	cd_comnd_undefined,
	/* BB */	cd_comnd_undefined,
	/* BC */	cd_comnd_undefined,
	/* BD */	cd_comnd_undefined,
	/* BE */	cd_comnd_undefined,
	/* BF */	cd_comnd_undefined,

	/* C0 */	cd_comnd_reserved,
	/* C1 */	cd_comnd_reserved,
	/* C2 */	cd_comnd_reserved,
	/* C3 */	cd_comnd_undefined,
	/* C4 */	cd_comnd_undefined,
	/* C5 */	cd_comnd_undefined,
	/* C6 */	cd_comnd_undefined,
	/* C7 */	cd_comnd_undefined,
	/* C8 */	cd_comnd_undefined,
	/* C9 */	cd_comnd_undefined,
	/* CA */	cd_comnd_undefined,
	/* CB */	cd_comnd_undefined,
	/* CC */	cd_comnd_undefined,
	/* CD */	cd_comnd_undefined,
	/* CE */	cd_comnd_undefined,
	/* CF */	cd_comnd_undefined,

	/* D0 */	cd_comnd_undefined,
	/* D1 */	cd_comnd_undefined,
	/* D2 */	cd_comnd_undefined,
	/* D3 */	cd_comnd_undefined,
	/* D4 */	cd_comnd_undefined,
	/* D5 */	cd_comnd_undefined,
	/* D6 */	cd_comnd_undefined,
	/* D7 */	cd_comnd_undefined,
	/* D8 */	cd_comnd_undefined,
	/* D9 */	cd_comnd_undefined,
	/* DA */	cd_comnd_undefined,
	/* DB */	cd_comnd_undefined,
	/* DC */	cd_comnd_undefined,
	/* DD */	cd_comnd_undefined,
	/* DE */	cd_comnd_undefined,
	/* DF */	cd_comnd_undefined,

	/* E0 */	cd_comnd_undefined,
	/* E1 */	cd_comnd_undefined,
	/* E2 */	cd_comnd_undefined,
	/* E3 */	cd_comnd_undefined,
	/* E4 */	cd_comnd_undefined,
	/* E5 */	cd_comnd_undefined,
	/* E6 */	cd_comnd_undefined,
	/* E7 */	cd_comnd_undefined,
	/* E8 */	cd_comnd_undefined,
	/* E9 */	cd_comnd_undefined,
	/* EA */	cd_comnd_undefined,
	/* EB */	cd_comnd_undefined,
	/* EC */	cd_comnd_undefined,
	/* ED */	cd_comnd_undefined,
	/* EE */	cd_comnd_undefined,
	/* EF */	cd_comnd_undefined,

	/* F0 */	cd_comnd_service,
	/* F1 */	cd_comnd_sledge,
	/* F2 */	cd_comnd_focus,
	/* F3 */	cd_comnd_turntable,
	/* F4 */	cd_comnd_radial,
	/* F5 */	cd_comnd_undefined,
	/* F6 */	cd_comnd_undefined,
	/* F7 */	cd_comnd_undefined,
	/* F8 */	cd_comnd_undefined,
	/* F9 */	cd_comnd_undefined,
	/* FA */	cd_comnd_undefined,
	/* FB */	cd_comnd_undefined,
	/* FC */	cd_comnd_undefined,
	/* FD */	cd_comnd_undefined,
	/* FE */	cd_comnd_undefined,
	/* FF */	cd_comnd_undefined
	};

/* -------------------------------------------------------------------------- */

/******************************************************************************/
/******************************************************************************/

static	void	cd_comnd_reserved(unsigned int param)
{
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_userdef(unsigned int param)
{
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_undefined(unsigned int param)
{
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}

/******************************************************************************/
/******************************************************************************/

static	void	cd_comnd_opentray(unsigned int param)		/* 0Ah */
{
	cd_comnd_respond(COMND_TRAYOPEN);	/* send tray open command */
	return;
}
static	void	cd_comnd_closetray(unsigned int param)		/* 0Bh */
{
	cd_comnd_respond(COMND_TRAYCLOSED);	/* send tray closed command */
	return;
}
static	void	cd_comnd_setmode(unsigned int param)		/* 15h */
{
	cd_comnd_respond(COMND_MODESTATUS | param);
	return;
}
static	void	cd_comnd_getdiscstatus(unsigned int param)	/* 50h */
{
	cd_comnd_respond(COMND_DISCSTATUS | 0x0003);
	return;
}
static	void	cd_comnd_setvolume(unsigned int param)		/* 51h */
{
	cd_comnd_respond(COMND_VOLUMELEVEL | param);
	return;
}
static	void	cd_comnd_setdacmode(unsigned int param)		/* 70h */
{
	cd_comnd_respond(COMND_DACMODE | param);
	return;
}

/******************************************************************************/
/******************************************************************************/

static	void	cd_comnd_gotoabsmin(unsigned int param)		/* 10h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	goto_mins = param;
	return;
}
static	void	cd_comnd_gotoabssec(unsigned int param)		/* 11h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	goto_secs = param;
	return;
}
static	void	cd_comnd_plabstrtmin(unsigned int param)	/* 20h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	abplay_amins = param;
	return;
}
static	void	cd_comnd_plabstrtsec(unsigned int param)	/* 21h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	abplay_asecs = param;
	return;
}
static	void	cd_comnd_plabstrtfrm(unsigned int param)	/* 22h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	abplay_afrms = param;
	return;
}
static	void	cd_comnd_plabstopmin(unsigned int param)	/* 23h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	abplay_bmins = param;
	return;
}
static	void	cd_comnd_plabstopsec(unsigned int param)	/* 24h */
{
	cd_comnd_playreset();			/* reset the current play stuff */
	abplay_bsecs = param;
	return;
}

/******************************************************************************/
/******************************************************************************/

static	void	cd_comnd_service(unsigned int param)		/* F0 */
{
	/* (00h) Service mode off */
	/* (01h) Request Servo version no and activate service mode */
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_sledge(unsigned int param)		/* F1h */
{
	/* (00h) Sledge off */
	/* (01h) Sledge outside for 300msec */
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_focus(unsigned int param)		/* F2h */
{
	/* (00h) Focus off */
	/* (01h) Focus on */
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_turntable(unsigned int param)		/* F3h */
{
	/* (00h) Turntable motor off */
	/* (01h) Turntable motor on */
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}
static	void	cd_comnd_radial(unsigned int param)		/* F4h */
{
	/* (00h) Radial off */
	/* (01h) Radial on */
	cd_comnd_senderror(COMND_E_ILLCOMMAND);
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of CD_COMND.H							      */
/******************************************************************************/
