/******************************************************************************/
/* CD_MENU.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_struc.h"
#include "st_aes.h"
#include "st_bind.h"
#include "st_lib.h"
#include "cd_bind.h"

#include "st_hard.h"
#include "cdmonusa.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_scrhandle;
extern	int	gl_charwide;

extern	CDROM	*gl_actdocu;

extern	GRECT	cd_titlrect;
extern	GRECT	cd_datarect;

extern	long	cd_visx;
extern	long	cd_visy;

extern	int	cd_sizestartx;		/* starting x position of size field */
extern	int	cd_stimstartx;		/* starting x position of start time */
extern	int	cd_etimstartx;		/* starting x position of end time */

/* -------------------------------------------------------------------------- */

extern	unsigned int	cd_defdevno;

/* -------------------------------------------------------------------------- */

extern	unsigned long	cd_cdrmlead;
extern	unsigned long	cd_cdrmtail;

extern	unsigned long	cd_sesslead;
extern	unsigned long	cd_sesstail;

extern	unsigned long	cd_traklead;
extern	unsigned long	cd_traktail;

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_dial_cdromtitle()
{
register unsigned char	*cp;
register unsigned char 	*t; 
register OBJECT	*Tree;
register int	Respons;
unsigned char	s[ MAX_ROMNAME ];
GRECT	box;

	cp = gl_actdocu->CdRomName;

	cd_select_title();
	Tree = st_objc_get_tree(CDROMTTL);
	st_objc_form_center(Tree, &box);
	strcpy((t = TePtext(CDTTLSTR)), cp);
	st_objc_draw_tree(Tree);
	for (;;)
	{
		Respons = form_do(Tree, CDTTLSTR);
		if (Respons == CDTTLCAN)
			break;

		strcpy(s, t);
		st_str_trim(s);
		if (strlen(s))
			break;

		st_error_message(E_CDROMTITLE);
		objc_change(Tree, Respons, 0, box.g_x, box.g_y, box.g_w, box.g_h, NORMAL, 1);
		continue;
	}
	Tree[ Respons ].ob_state &= ~SELECTED;
	st_objc_erase_tree(Tree);

	if ((Respons == CDTTLCAN) || !strcmp(cp, s))
	{
		cd_select_title();
		return;
	}

	if (!cd_saveundo())
		return;

	strcpy(cp, s);
	cd_display_title(&cd_titlrect);
	st_set_savedocu();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_add_comments()
{
register ITEM	*item;
register unsigned char	*cp;
register unsigned char 	*t; 
register OBJECT	*Tree;
register int	Respons;

	item = gl_actdocu->SelItem;
	cp = item->Comments;

	if (item->Settings & IT_LAST)
		return;

	Tree = st_objc_get_tree(COMMENTS);
	strcpy((t = TePtext(COMNTSTR)), cp);

	st_objc_draw_tree(Tree);
	Respons = form_do(Tree, COMNTSTR);
	Tree[ Respons ].ob_state &= ~SELECTED;
	st_objc_erase_tree(Tree);

	if ((Respons == COMNTCAN) || !strcmp(cp, t))
		return;

	if (!cd_saveundo())
		return;

	strcpy(cp, t);
	cd_currsel(&cd_datarect);
	cd_display_item(item, &cd_datarect);
	cd_select_item(item, &cd_datarect);
	cd_currsel(&cd_datarect);
	st_set_savedocu();
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_edit_filename()
{
register ITEM	*item;
register unsigned char	*cp;
register long	err;
unsigned char	filename[ MAX_PATHNAME ];
FSELDTA	theDTA;

	item = gl_actdocu->SelItem;
	cp = item->PathName;

	if (item->Settings & (IT_LAST | IT_SESSION | IT_TRACK))
		return;

	strcpy(filename, cp);
	err = fsel_file(cd_defdevno, filename, &theDTA);
	if (err == 0)
		return;
	if (err < 0)
	{
		char	mess[200];
		sprintf(mess, "[1][Error in File Selector Box!|(Internal Error Number = %ld)][OK]", err);
		form_alert(1, mess);
		return;
	}

	if (!cd_saveundo())
		return;

	item->Length = theDTA.d_fsize;

	strcpy(cp, filename);
	cd_currsel(&cd_datarect);
	cd_display_item(item, &cd_datarect);
	cd_select_item(item, &cd_datarect);
	cd_currsel(&cd_datarect);
	cd_update_time(gl_actdocu);
	cd_update_disp();
	st_set_savedocu();
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 */

void	cd_update_time(docu)
CDROM	*docu;
{
register ITEM	*item;
register ITEM	*track;
register ITEM	*session;
register unsigned long	nofrms;
register unsigned long	totl_frms;
register unsigned long	trak_frms;
register unsigned long	sess_frms;
register unsigned long	length;

	item = docu->FirstItem;
	track = NULL;
	session = NULL;

	sess_frms = trak_frms = totl_frms = cd_cdrmlead;
	while (item != NULL)
	{
		if ((item->Settings & (IT_LAST | IT_SESSION | IT_TRACK)) && (track != NULL))
		{
			totl_frms += cd_traktail;
			track->FrameLength = totl_frms - trak_frms;
			track = NULL;
		}
		if ((item->Settings & (IT_LAST | IT_SESSION)) && (session != NULL))
		{
			totl_frms += cd_sesstail;
			session->FrameLength = totl_frms - sess_frms;
			session = NULL;
		}
		if (item->Settings & IT_LAST)
		{
			item->FrameStart = totl_frms;
			item->FrameLength = cd_cdrmtail;
			break;
		}

		item->FrameStart = totl_frms;

		if (item->Settings & IT_SESSION)
		{
			session = item;
			sess_frms = totl_frms;
			nofrms = cd_sesslead;
		}
		if (item->Settings & IT_TRACK)
		{
			track = item;
			trak_frms = totl_frms;
			nofrms = cd_traklead;
		}
		if (item->Settings & IT_ITEM)
		{
			length = item->Length;
			if (length % FSEL_BUFFSIZE) length += FSEL_BUFFSIZE;
			length /= FSEL_BUFFSIZE;
			length *= FSEL_BUFFSIZE;

			nofrms = length / MAX_FRMSIZE;
			if (length % MAX_FRMSIZE) nofrms ++;
			item->FrameLength = nofrms;
		}
		totl_frms += nofrms;
		item = item->next;
	}
	return;
}

/* -----------------------------------------------------------------------------
 */

void	cd_update_disp()
{
register CDROM	*docu = gl_actdocu;
register ITEM	*item;
register long	liny;
register long	miny;
register long	maxy;
register int	rasx;
register int	rasy;
register int	offx;
register int	ifsel;
int	pxy[4];
unsigned char	mess[200];

	liny = 0L;
	miny = cd_visy;
	maxy = cd_visy + (long)(cd_datarect.g_h - 1);

	cd_currsel(&cd_datarect);
	st_v_clip_boxon(&cd_datarect);
	st_mouse_hide();

	for (item = docu->FirstItem ; item != docu->LastItem ; item = item->next)
	{
		liny += (long)item->Hite;

		if (liny < miny)
		{
			continue;
		}

		cd_display_color(item);

		ifsel = ((item->Settings & IT_SELECTED) ? TRUE : FALSE);
		if (ifsel)
		{
			vsf_color(gl_scrhandle, BLACK);
		}
		offx = cd_datarect.g_x - (int)cd_visx - 1 + gl_charwide;

		rasy = cd_datarect.g_y + (int)(liny - cd_visy);
		pxy[1] = rasy - item->Hite;
		pxy[3] = rasy - 2;
		rasy -= item->OffsetY;

		if (item->Settings & IT_ITEM)
		{
			rasx = offx + cd_sizestartx;
			if (ifsel)
			{
				pxy[0] = rasx;
				pxy[2] = rasx + gl_charwide * 9;
				vr_recfl(gl_scrhandle, pxy);

				vswr_mode(gl_scrhandle, MD_XOR);
			}

			sprintf(mess, "%9ld", item->Length);
			v_gtext(gl_scrhandle, rasx, rasy, mess);

			if (ifsel)
			{
				vswr_mode(gl_scrhandle, MD_REPLACE);
			}
		}
		if (item->Settings & (IT_SESSION | IT_TRACK | IT_ITEM))
		{
			rasx = offx + cd_stimstartx;
			if (ifsel)
			{
				pxy[0] = rasx;
				pxy[2] = rasx + gl_charwide * 8;
				vr_recfl(gl_scrhandle, pxy);

				vswr_mode(gl_scrhandle, MD_XOR);
			}

			cd_display_framestr(item->FrameStart, mess);
			v_gtext(gl_scrhandle, rasx, rasy, mess);

			if (ifsel)
			{
				vswr_mode(gl_scrhandle, MD_REPLACE);
			}
		}
		if (item->Settings & (IT_SESSION | IT_TRACK | IT_ITEM))
		{
			rasx = offx + cd_etimstartx;
			if (ifsel)
			{
				pxy[0] = rasx;
				pxy[2] = rasx + gl_charwide * 8;
				vr_recfl(gl_scrhandle, pxy);

				vswr_mode(gl_scrhandle, MD_XOR);
			}

			cd_display_framestr(item->FrameLength, mess);
			v_gtext(gl_scrhandle, rasx, rasy, mess);

			if (ifsel)
			{
				vswr_mode(gl_scrhandle, MD_REPLACE);
			}
		}
		if (ifsel)
		{
			vsf_color(gl_scrhandle, WHITE);
		}
		if (liny > maxy)
		{
			break;
		}
	}
	cd_display_color(NULL);
	st_mouse_show();
	st_v_clip_boxoff(&cd_datarect);
	cd_currsel(&cd_datarect);
	return;
}

/******************************************************************************/
/* End of CD_MENU.C							      */
/******************************************************************************/
