/******************************************************************************/
/* ST_ABOUT.C								      */
/******************************************************************************/

#include "st_def.h"
#include "st_about.h"
#include "st_aes.h"

#include "cdmonusa.h"

/* -------------------------------------------------------------------------- */

extern	int	gl_nocolors;

/* -------------------------------------------------------------------------- */

#define RS_NUM_OBJS	9
#define	RS_NUM_TEDS	6

#define	RS_BOX_ROOT	0
#define	RS_NAM_AUTHOR	6
#define	RS_BAR_STATUS	7
#define RS_BUT_OK	8

#define	RS_MON_ROOTSPEC	0x0021141L
#define	RS_COL_ROOTSPEC	0x002114AL

static	unsigned char	*rs_strs[] =
	{
	"",
	"CD ROM Emulator 1.0",
	"July 18, 1994",
	"Copyright  1993,94",
	"Atari Computer Corporation, USA",
	"",						/* Author's name here */
	"Message Here 45678901234567890",
	""						/* button string */
	};

static	TEDINFO	rs_teds[] =
	{
	(char *)0x1L, (char *)0L, (char *)0L, 3, 0, 2, 0x1180, 0x0, -2, 20, 1,
	(char *)0x2L, (char *)0L, (char *)0L, 5, 0, 2, 0x1100, 0x0,  0, 18, 1,
	(char *)0x3L, (char *)0L, (char *)0L, 5, 0, 2, 0x1100, 0x0,  0, 20, 1,
	(char *)0x4L, (char *)0L, (char *)0L, 5, 0, 2, 0x1100, 0x0,  0, 32, 1,
	(char *)0x5L, (char *)0L, (char *)0L, 3, 0, 2, 0x1180, 0x0, -2, 30, 1,	/* Author's name here */
	(char *)0x6L, (char *)0L, (char *)0L, 3, 6, 2, 0x1180, 0x0, -2, 31, 1
	};

static	OBJECT	rs_objs[] =
	{
	-1,  1,  8, G_BOX    , 0x400, OUTLINED, (void *)0x021141L,  0,    0, 40, 8200,
	 2, -1, -1, G_BOXTEXT, 0x400, OUTLINED, (void *)0x000000L,  5,    1, 30,    1,
	 6,  3,  5, G_BOX    , 0x400, OUTLINED, (void *)0xFE1100L,  4,    3, 32, 6144,
	 4, -1, -1, G_TEXT   , 0x000, NORMAL  , (void *)0x000001L,  1, 0000, 30, 2048,
	 5, -1, -1, G_TEXT   , 0x000, NORMAL  , (void *)0x000002L,  1, 2048, 30, 2048,
	 2, -1, -1, G_TEXT   , 0x000, NORMAL  , (void *)0x000003L,  1, 4096, 30, 2048,
	 7, -1, -1, G_BOXTEXT, 0x400, OUTLINED, (void *)0x000004L,  2, 8196, 36,    1,
	 8, -1, -1, G_BOXTEXT, 0x400, OUTLINED, (void *)0x000005L,  3, 8198, 34,    1,
	 0, -1, -1, G_BUTTON , 0x627, NORMAL  , (void *)0x000010L, 14, 8198, 12,    1
	};

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * Routine to initialise the info dialog box and to show the infor dialog box.
 * called by global main routine
 */

void	st_info_show()
{
register OBJECT	*Tree = rs_objs;
register int	i, j;

/* set the specifications of the ROOT in the credit dialog */
/* box according to the resource (colour/mono) being loaded */

	Tree[ RS_BOX_ROOT ].ob_spec = (void *)((gl_nocolors < 16) ? RS_MON_ROOTSPEC : RS_COL_ROOTSPEC);

/* fix the tedinfo structure for the text strings to be displayed */

	for (i = 0 ; i < RS_NUM_TEDS ; i++)
	{
		j = (int)(rs_teds[i].te_ptext);
		rs_teds[i].te_ptext  = rs_strs[j];
		rs_teds[i].te_ptmplt =
		rs_teds[i].te_pvalid = rs_strs[0];
	}

/* fix all objects in the credit dialog box */

	for (i = 0 ; i < RS_NUM_OBJS ; i++)
	{
		j = (int)(Tree[i].ob_spec);

		switch (Tree[i].ob_type & 0x00FF)
		{
		case	G_BUTTON :	Tree[i].ob_spec = (void *)rs_strs[j];
					break;
		case	G_TEXT :
		case	G_BOXTEXT :	Tree[i].ob_spec = (void *)(&rs_teds[j]);
					break;
		}
		rsrc_obfix(Tree, i);
	}

/* set the authors name in the credit dialog box from the free strings */

	TePtext(RS_NAM_AUTHOR) = st_freestr(DIAL_INFO_AUTHOR);

/* also set the string for the exit button in credit dialog box */

	Tree[ RS_BUT_OK ].ob_spec = (void *)st_freestr(DIAL_INFO_OKBUTTON);

/* hide the exit button when credit dialog box is shown while initialising works */

	Tree[ RS_BUT_OK ].ob_flags |= HIDETREE;
	strcpy(TePtext(RS_BAR_STATUS), "");

/* display the credit dialog box */

	st_objc_draw_tree(Tree);
	return;
}

/* -----------------------------------------------------------------------------
 */

void	st_info_showstatus(which)
int	which;
{
register OBJECT	*Tree = rs_objs;
GRECT	box;

	strcpy(TePtext(RS_BAR_STATUS), st_freestr(which));
	st_objc_form_center(Tree, &box);
	objc_draw(Tree, RS_BAR_STATUS, MAX_DEPTH, box.g_x, box.g_y, box.g_w, box.g_h);
	return;
}

/* -----------------------------------------------------------------------------
 * Routine to erase the information dialog box. called by global main routine
 */

void	st_info_erase()
{
register OBJECT	*Tree = rs_objs;

	st_objc_erase_tree(Tree);
	Tree[ RS_BAR_STATUS ].ob_flags |= HIDETREE;
	Tree[ RS_BUT_OK ].ob_flags &= ~HIDETREE;
	return;
}

/* -----------------------------------------------------------------------------
 * routine to dispaly the info dialog box.  to be called by all the modules
 */

void	st_info_dialog()
{
register OBJECT	*Tree = rs_objs;

	st_objc_draw_tree(Tree);
	form_do(Tree, -1);
	st_objc_erase_tree(Tree);
	Tree[ RS_BUT_OK ].ob_state &= ~SELECTED;
	return;
}

/******************************************************************************/
/******************************************************************************/

/* -----------------------------------------------------------------------------
 * routine to set the medium/high resolution icons in different resource trees
 */

void	st_init_medicons()
{
	return;
}

/******************************************************************************/
/* End of ST_ABOUT.C							      */
/******************************************************************************/
