	.include	'jaguar.inc'

	.globl		Lister

PATTERN		equ	$20000

; At this point I will attempt to set up an object list
; This list will contain a single Scaled Bit map object
; and a Stop object.  This object is 256 pixels wide

Lister:
	move.l	#0,BORD1

	move.l	#listbuf,d0		; Space alloted for Object List
	and.l	#$ffffffe0,d0		; Assure alignment
	move.l	d0,d5			; save address for later

	move.l	d0,a0			; a0 has the object start 
	move.l	#PATTERN,d0		; get data address
	moveq	#8,d1
	lsl.l	d1,d0			; shift into position

	and.l	#$fffff800,d0		; mask off junk
	move.l	d0,(a0)			; store

; This places the partial result in the correct spot in memory
; Then, in the next part, it 'or's the rest of the data in.
; Doing it all in registers would be faster, but I want to see the results

	move.l	d5,d0			; This point to the start of the OL
	add.l	#16,d0			; Point to the soon to be next object
	move.l	d0,d2			; Save pointer for bottom half
	moveq	#11,d1
	lsr.l	d1,d0			; shift for top part
	or.l	d0,(a0)+		; or in the new data

; do the bottom half in the next long word

	moveq	#21,d1
	lsl.l	d1,d2			; shift for bottom part
	and.l	#$ff000000,d2		; mask off junk
	move.l	d2,(a0)			; store (prematurely)

; Same comment here about doing this in registers instead of memory

	move.w	#200,d0			; this is the height (fixed @200)
					; can't use moveq, it will sign extend

	moveq	#14,d1
	lsl.l	d1,d0			; shift it again
	or.l	d0,(a0)			; or in the new data
	move.l	#0,d0			; this is the ypos (fixed @0)
	lsl.l	#3,d0
	or.l	d0,(a0)			; or in the new data

;	or.l	#1,(a0)+		; or in the object type
	or.l	#0,(a0)+		; or in the object type

; That completes another long word, First phrase done

	move.l	#$00000005,d0		; No flags set
	move.l	d0,(a0)+		; Set for 32 phrases
					; 
; That completes another long word

	moveq	#0,d0			; Make Room For Data

; The next block of stuff builds the next long word
; It or's in the data and then shifts until everything is
; in place.  Note that the moveq # lsl pattern can be
; replaced by lsl # for all cases where the shift is less
; than 9.  This is not done here for consistency.  The
; speed hit this way IS noticable

; 32 phrases has NO low order bits
	ori.l	#0,d0

; Insert dwidth
	moveq	#10,d1			; make room for dwidth
	lsl.l	d1,d0

	ori.l	#80,d0

; Insert pitch
	moveq	#3,d1			; make room for pitch
	lsl.l	d1,d0

	ori.l	#$1,d0

; Insert depth
	moveq	#3,d1			; make room for depth
	lsl.l	d1,d0

	ori.l	#$4,d0

; Insert xpos
	moveq	#12,d1			; make room for xpos
	lsl.l	d1,d0

	ori.l	#$0,d0
	
; Finally store the data
	move.l	d0,(a0)+

; This completes the bit map object

obj2:

; ******************************
; START OBJECT NUMBER TWO
; ******************************

	move.l	a0,d4
	move.l	#GLASS,d0		; get data address
	moveq	#8,d1
	lsl.l	d1,d0			; shift into position

	and.l	#$fffff800,d0		; mask off junk
	move.l	d0,(a0)			; store

; This places the partial result in the correct spot in memory
; Then, in the next part, it 'or's the rest of the data in.
; Doing it all in registers would be faster, but I want to see the results

	move.l	d4,d0			; This points to the start this object
	add.l	#16,d0			; Point to the soon to be next object
	move.l	d0,d2			; Save pointer for bottom half
	moveq	#11,d1
	lsr.l	d1,d0			; shift for top part
	or.l	d0,(a0)+		; or in the new data

; do the bottom half in the next long word

	moveq	#21,d1
	lsl.l	d1,d2			; shift for bottom part
	and.l	#$ff000000,d2		; mask off junk
	move.l	d2,(a0)			; store (prematurely)

; Same comment here about doing this in registers instead of memory

	move.w	#112,d0			; this is the height (fixed @32)

	moveq	#14,d1
	lsl.l	d1,d0			; shift it again
	or.l	d0,(a0)			; or in the new data
	move.l	obj2y,d0		; this is the ypos (fixed @0)
	lsl.l	#3,d0
	or.l	d0,(a0)			; or in the new data

	or.l	#0,(a0)+		; or in the object type

; That completes another long word, First phrase done

	move.l	#$00004001,d0		; Set RMW
	move.l	d0,(a0)+

; That completes another long word

	moveq	#0,d0			; Make Room For Data

; The next block of stuff builds the next long word
; It or's in the data and then shifts until everything is
; in place.  Note that the moveq # lsl pattern can be
; replaced by lsl # for all cases where the shift is less
; than 9.  This is not done here for consistency.  The
; speed hit this way IS noticable

	ori.l	#28,d0

; Insert dwidth
	moveq	#10,d1			; make room for dwidth
	lsl.l	d1,d0

	ori.l	#28,d0

; Insert pitch
	moveq	#3,d1			; make room for pitch
	lsl.l	d1,d0

	ori.l	#$1,d0

; Insert depth
	moveq	#3,d1			; make room for depth
	lsl.l	d1,d0

	ori.l	#$4,d0			; 16 bpp

; Insert xpos
	moveq	#12,d1			; make room for xpos
	lsl.l	d1,d0

	or.l	obj2x,d0
	
; Finally store the data
	move.l	d0,(a0)+

; This completes the bit map object

	moveq	#0,d0
	move.l	d0,(a0)+		; That sure was easy
	moveq	#4,d0
	move.l	d0,(a0)

; That was a stop object with all zeros for data

; Well this should be set up now

	swap	d5
	move.l	d5,OLP			; and other bits of the OL address

	move.l	#$FFFFFFFF,BORD1
	rts

.data

.even
		dcb.l	32,0
listbuf:	dcb.l	64,0

		dc.l	0
		dc.l	0
obj2x:
	dc.l	128
obj2y:
	dc.l	100

GLASS:
		dcb.l	60*112,0


.if 0
GLASS:
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55
		dc.b	0,0,0,0,$55,$55,$55,$55

		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
		dc.b	$aa,$aa,$aa,$aa,$ff,$ff,$ff,$ff
.endif

